org.springframework.batch.core.listener

## Class JobParameterExecutionContextCopyListener

- java.lang.Object
- - org.springframework.batch.core.listener.StepExecutionListenerSupport
  - - org.springframework.batch.core.listener.JobParameterExecutionContextCopyListener

- All Implemented Interfaces:
    StepExecutionListener, StepListener

      public class JobParameterExecutionContextCopyListener
      extends StepExecutionListenerSupport

  This class can be used to automatically copy items from the `JobParameters` to the `Step` `ExecutionContext`. A list of keys should be provided that correspond to the items in the `Step` `ExecutionContext` that should be copied.
  Since:
    2.0
  Author:
    Dave Syer

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `JobParameterExecutionContextCopyListener()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `beforeStep(StepExecution stepExecution)` Copy attributes from the `JobParameters` to the `Step` `ExecutionContext`, if not already present.
    `void` | `setKeys(java.lang.String[] keys)`

    - ### Methods inherited from class org.springframework.batch.core.listener.StepExecutionListenerSupport

      `afterStep`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### JobParameterExecutionContextCopyListener

          public JobParameterExecutionContextCopyListener()

  - ### Method Detail

    - #### setKeys

          public void setKeys(java.lang.String[] keys)

      Parameters:
        `keys` - A list of keys corresponding to items in the `JobParameters` that should be copied.

    - #### beforeStep

          public void beforeStep(StepExecution stepExecution)

      Copy attributes from the `JobParameters` to the `Step` `ExecutionContext`, if not already present. The the key is already present we assume that a restart is in operation and the previous value is needed. If the provided keys are empty defaults to copy all keys in the `JobParameters`.
      Specified by:
        `beforeStep` in interface `StepExecutionListener`
      Overrides:
        `beforeStep` in class `StepExecutionListenerSupport`
      Parameters:
        `stepExecution` - instance of `StepExecution`.